﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _1348762VirtualGridSelectionRange
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();

            this.radVirtualGrid1.ColumnCount = 5;
            this.radVirtualGrid1.RowCount = 200;
            this.radVirtualGrid1.CellValueNeeded += radVirtualGrid1_CellValueNeeded;
            this.radVirtualGrid1.EnablePaging = true;
            this.radVirtualGrid1.PageSize = 10; 
            this.radVirtualGrid1.MultiSelect = true;

            //radVirtualGrid1.VirtualGridElement.Selection.BeginSelection(3, 1, radVirtualGrid1.MasterViewInfo, true);
            //radVirtualGrid1.VirtualGridElement.Selection.ExtendCurrentRegion(3, 2);

            //radVirtualGrid1.VirtualGridElement.Selection.BeginSelection(5, 1, radVirtualGrid1.MasterViewInfo, true);
            //radVirtualGrid1.VirtualGridElement.Selection.ExtendCurrentRegion(5, 2);

            //radVirtualGrid1.VirtualGridElement.Selection.BeginSelection(13, 1, radVirtualGrid1.MasterViewInfo, true);
            //radVirtualGrid1.VirtualGridElement.Selection.ExtendCurrentRegion(14, 2);

            this.radVirtualGrid1.Selection.ClearSelection();
            this.radVirtualGrid1.PageChanging += radVirtualGrid1_PageChanging;
            this.radVirtualGrid1.PageChanged += radVirtualGrid1_PageChanged;
        }

        int _currentRowIndex = -1;
        List<SelectionRegion> _selectionRegions = new List<SelectionRegion>();
        int TotalFilteredRecords = 0;

        private void radVirtualGrid1_PageChanging(object sender, Telerik.WinControls.UI.VirtualGridPageChangingEventArgs e)
        {
            var selectionRegions = this.radVirtualGrid1.Selection.SelectedRegions;
  
            var offset = Math.Abs(e.NewIndex - this.radVirtualGrid1.PageIndex);
            var pageIndex = e.NewIndex > this.radVirtualGrid1.PageIndex
                            ? this.radVirtualGrid1.PageSize * offset
                            : -this.radVirtualGrid1.PageSize * offset;
            _currentRowIndex = this.radVirtualGrid1.Selection.CurrentRowIndex;
  
            _selectionRegions.Clear();
            foreach (var region in selectionRegions)
            {
                var newRegion = new SelectionRegion(region.Top + pageIndex, region.Left,
                    region.Bottom + pageIndex, region.Right, region.ViewInfo);
                _selectionRegions.Add(newRegion);
            }
        }

        private void radVirtualGrid1_PageChanged(object sender, Telerik.WinControls.UI.VirtualGridEventArgs e)
        { 
            for (var idx = 0; idx < _selectionRegions.Count; idx++)
            {
                var newRegion = _selectionRegions[idx];
  
                this.radVirtualGrid1.VirtualGridElement.Selection.BeginSelection(newRegion.Top, newRegion.Left, this.radVirtualGrid1.MasterViewInfo, idx != 0);
                this.radVirtualGrid1.VirtualGridElement.Selection.ExtendCurrentRegion(newRegion.Bottom, newRegion.Left);
            }
        }

        private void radVirtualGrid1_CellValueNeeded(object sender, Telerik.WinControls.UI.VirtualGridCellValueNeededEventArgs e)
        {
            e.Value = "Data " + e.RowIndex + " " + e.ColumnIndex;
        }
    }
}